#define WIN32_LEAN_AND_MEAN
#define CONSOLE_WINDOW 1
#define FRAMERATE 60
#define PI 3.1415926535
#define ZOOM_SPEED 2.0f
#define SHIP_SCALE 1.00f
#define LOOK_SPEED 0.02f
#define LOOK_ZOOM_SPEED 1.0f
#define EYE_Y_SPEED 0.5f
#define LOOK_MIN -90.0f
#define LOOK_MAX  90.0f
#define LOOK_ZOOM_MIN 0.0f
#define LOOK_ZOOM_MAX 149.0f
#define LOOK_X 0.0f
#define LOOK_Y -23.5f
#define LOOK_Z -122.0f
#define LOOK_RADIUS 175.0f
#define SelBufferSize 512
#define BUFSIZE 1024
#define MENU_ANGLE_STEP 0.1f
#define TITLE_LETTER_GAPS 0.49f

//// for 1600 x 700
//#define HEIGHT_MAP_FILE "img\\land-1600x700.bmp"
//#define MAP_X       1600        // size of map along x-axis
//#define MAP_Z       700        // size of map along z-axis
//#define MAP_SCALE   1.0f     // the scale of the terrain map
//#define MAP_TEXTURE_SCALE 10.0f

//// for 800 x 350
//#define HEIGHT_MAP_FILE "img\\land-800x350-dark.bmp"
//#define MAP_X       800        // size of map along x-axis
//#define MAP_Z       350        // size of map along z-axis
//#define MAP_SCALE   2.0f     // the scale of the terrain map
//#define MAP_TEXTURE_SCALE 10.0f

// for 400 x 175
#define HEIGHT_MAP_FILE "img\\land-400x175-dark.bmp"
#define MAP_X       400        // size of map along x-axis
#define MAP_Z       175        // size of map along z-axis
#define MAP_SCALE   4.0f     // the scale of the terrain map
#define MAP_TEXTURE_SCALE 10.0f

#define WATER_SCALE 22.0f
#define WATER_SIZE  90.0f

// Dimensions of board
//
#define BOARD_WIDTH  20
#define BOARD_LENGTH 20

#define FULLSCREEN true

#define MAX_TURRETS 32		// The most anyone can have is 4 10-unit ships, hence 32 guns


struct t_list
{
	float x;
	float z;
	int idx;
};

//                  _        _
//  _ __  _ __ ___ | |_ ___ | |_ _   _ _ __   ___  ___
// | '_ \| '__/ _ \| __/ _ \| __| | | | '_ \ / _ \/ __|
// | |_) | | | (_) | || (_) | |_| |_| | |_) |  __/\__ \
// | .__/|_|  \___/ \__\___/ \__|\__, | .__/ \___||___/
// |_|                           |___/|_|
//            Functions found in harborwars.cpp
/////////////////////////////////////////////////////////
void binocularMode(void);
void targetingMode(void);
void battleMode(void);
void myDelay(void);		// I had a problem with my 'i' counter...so now it's own function.
void RenderModel(t3DModel);
void OrthoMode(int, int, int, int);
void PerspectiveMode(void);
void HeadsUpDisplay(void);
bool IsInBox(int, int, int, int, int, int);
void BuildLand(int, int, char *);
void DrawMenu(void);
void DrawWater(void);
void DrawSky(void);
void DrawTerrain(void);
void DrawGrid(void);
void DrawAiGrid(void);
void DrawShips(void);
void DrawFPS(void);
void DrawShotsRemaining(void);
void DrawTotalHits(void);
void ShipPlacement(void);
void InitHumanMissiles(void);
void AnimateHumanMissiles(void);
void ChooseAiTargets(void);
void InitAiMissiles(void);
void AnimateAiMissiles(void);
void RandomizeHumanGuns(void);
void HumanQuicksort(int, int);
int HumanPartition(int, int);
int processHits(GLint, GLuint *, int);
