#ifndef __MISSILE_H
#define __MISSILE_H

#define MISSILE_DEAD 0
#define MISSILE_SLEEPING 1
#define MISSILE_FLYING 2
#define MISSILE_APEX 57.0f	// This needs to be 57.0f !!!
#define MISSILE_TIME 17.0f  // This needs to be 17.0f !!!

class Missile
{
private:
	int fps; // Desired frames per second
	int time_counter;	// Counts animation frame
	int target_x;		// X-component of target's grid coordinates
	int target_z;		// Z-component of target's grid coordinates
	bool alive;			// is missile done?
	float sleep_secs;	// seconds to sleep before being born
	float born;			// The time that was in the timer when born
	float lived;		// tells how long missile has been living
	float elapsed_time;	// elapsed time
	float max_time;		// how old until we die?
	float x1;	// Initial X coordinate
	float y1;	// Initial Y coordinate
	float z1;	// Initial Z coordinate
	float x2;	// Destination X coordinate
	float y2;	// Destination Y coordinate
	float z2;	// Destination Z coordinate
	float apex;	// Apex of trajectory.
	float m;	// multiplyer for parabolic equasion
	float y_angle;	// This doesn't change throughout the entire trajectory
	float dx, dz;	// difference between x1 and x2, and z1 and z2 respectively
	CHiResTimer m_timer;	// Timer for missiles.
	
 
public:

	Missile();
	~Missile();
	void Init(void);
	void InitTime(float, float);
	void Precalculate();
	void SetStartPoint(float, float, float);
	void SetEndPoint(float, float, float);
	void SetTargetCoord(int, int);
	int  GetTargetXCoord(void);
	int  GetTargetZCoord(void);
	void SetApex(float);
	void Animate(void);
	short TranslateAndRotate(float, float);
};


#endif