#include "somefont.h"

somefont::somefont(void)
{
}

void somefont::init(char *fontName, int fontSize, float depth, HDC &g_HDC)
{

	HFONT hFont;						// windows font
	
	characters = glGenLists(256);		// create storage for 96 characters

	if (stricmp(fontName, "symbol") == 0)
	{
		hFont = CreateFont(fontSize, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, SYMBOL_CHARSET,
							OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY,
							FF_DONTCARE | DEFAULT_PITCH, fontName);
	}
	else
	{
		 hFont = CreateFont(fontSize, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, ANSI_CHARSET, 
							OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY,
							FF_DONTCARE | DEFAULT_PITCH, fontName);
	}

	if (!hFont)
		characters = 0;

	SelectObject(g_HDC, hFont);
	wglUseFontOutlines(g_HDC, 0, 255, characters, 0.0f, depth, WGL_FONT_POLYGONS, gmf);

}

void somefont::ClearFont(void)
{
	glDeleteLists(characters, 256);
	characters = 0;
}

void somefont::PrintString(string Zstring)
{
	float length = 0;

	if (Zstring.empty())
		return;
    
	for (unsigned int loop = 0; loop < Zstring.size() ;loop++)
	{
		length += gmf[Zstring[loop]].gmfCellIncX;		// increase length by character's width
	}
	

	glPushMatrix();
		glTranslatef(-length/2,0.0f,0.0f);					// translate to center text

		// draw the text
		glPushAttrib(GL_ALL_ATTRIB_BITS);
			glListBase(characters);
			glCallLists(Zstring.size(), GL_UNSIGNED_BYTE, Zstring.c_str());
		glPopAttrib();
	glPopMatrix();

}

void somefont::PrintString(int integer)
{
	float length = 0;

	int ones = 0;
	int tens = 0;
	int hundreds = 0;

	string ascii_number;
	ascii_number.empty();

	hundreds = integer / 100;
	integer = integer - (hundreds * 100);

	tens = integer / 10;
	integer = integer - (tens * 10);

	ones = integer;
    	
	if(hundreds != 0) {
		ascii_number += hundreds + 48;
		ascii_number += tens + 48;
		ascii_number += ones + 48;
	} else if(tens != 0) {
		ascii_number += 48;
		ascii_number += tens + 48;
		ascii_number += ones + 48;
	} else {
		ascii_number += 48;
		ascii_number += 48;
		ascii_number += ones + 48;
	}

	for (unsigned int loop = 0; loop < length; loop++)
	{
		length += gmf[ascii_number[loop]].gmfCellIncX;		// increase length by character's width
	}
	glTranslatef(-length/2,0.0f,0.0f);					// translate to center text

	// draw the text
	glPushAttrib(GL_ALL_ATTRIB_BITS);
		glListBase(characters);
		glCallLists(ascii_number.size(), GL_UNSIGNED_BYTE, ascii_number.c_str());	
	glPopAttrib();

}

somefont::~somefont(void)
{
}
