/*
   somepoint.h - v0.1
   
   the "some" point class header file.
   
   Copyright (c) 2003 Patrick Lynch <plynch@sphere.org>
   Copyright (c) 2003 Brian Jared <bjared@g3.org>
   
   v 0.1
   - Inital concept and layout completed.
   
*/

#pragma once
#ifndef __SOMEPOINT_H
#define __SOMEPOINT_H

// needed for print functions
#include <iostream>
//#include <stdio.h>

// needed for draw
#include <windows.h>
#include <gl/gl.h>

using std::cout;
using std::endl;


class somepoint
{
private:
	float x; float y; float z;
	float r_color; float g_color; float b_color; float a_color;

public:
	somepoint(void);

	somepoint(float, float, float);

	void operator=(const somepoint &);

	somepoint operator-(const somepoint &);

	somepoint operator+(const somepoint &);

	void SetCord(float, float, float);

	void SetRandCord(float, float, bool);

	somepoint MidPoint(const somepoint &);

	// get the individual x y z coords.
	float getx() { return x; }
	float gety() { return y; }
	float getz() { return z; }

	float dx(const somepoint &);

	float dy(const somepoint &);

	float dz(const somepoint &);

	void addX(float dx) { x += dx; }

	void addY(float dy) { y += dy; }

	void addZ(float dz) { z += dz; }

	void setcolor(float, float, float, float);

	void SetRandColor(bool);

	void printout();

	void printout(FILE *);

	void draw(void);

	~somepoint(void);
};

#endif
