/*
   somevector.h - v0.1
   
   the "some" vector header file
   
   Copyright (c) 2003 Patrick Lynch <plynch@sphere.org>
   Copyright (c) 2003 Brian Jared <bjared@g3.org>
   
   v 0.1
   - Inital concept and layout completed.
   
*/
#pragma once
#ifndef __SOMEVECTOR_H
#define __SOMEVECTOR_H

#include "somepoint.h"
#include <cmath>

class somevector
{
private:
	somepoint IP;		// initial point
	somepoint TP;		// terminal point
	somepoint dir;		// holds the direction vector
	float length;		// the length / norm of the vector

public:
	somevector(void);

	somevector(float, float, float);

	somevector(somepoint &);

	somevector(somepoint &, somepoint &);

	void SetIP(somepoint &P) { IP = P; }
	float getlength() { return length; }
	float Xdir() { return dir.getx(); }
	float Ydir() { return dir.gety(); }
	float Zdir() { return dir.getz(); }

	void calculate(float, float, float);

	void calculate(somepoint &);

	void calculate(somepoint &, somepoint &);

	somevector operator-(somevector &);

	somevector operator+(somevector &);

	float DotProduct(somevector &);

	somevector CrossProduct(somevector &);

	void CrossProduct(somepoint &, somepoint &, somepoint &);

	void normalize();

	void DefineAsNormal();

	void draw();

	void printout();

	~somevector(void);
};

#endif