#ifndef __TEXTURE_H
#define __TEXTURE_H

#include "images.h"

class Texture
{
private:

	int width;				// Width of texture
	int height;				// Height of texture
	unsigned int texID;		// the texture object id
	unsigned char *data;	// the texture data
	imgTypes_t	type;		// Type of the texture

public:

	Texture();
	Texture(char *);
	Texture(char *, bool);
	~Texture();
	bool LoadTextureFile(char *);
	bool LoadTextureFile(char *, bool);
	void Init();
	unsigned char * GetData();
	int GetWidth();
	int GetHeight();
	imgTypes_t GetType();
	void SetTexID(unsigned int);
	unsigned int GetTexID();
	void TexGen(GLint);
	void BuildMipMaps();
	void Bind();
	void UnBind() { glBindTexture(GL_TEXTURE_2D, 0); }
};

#endif